﻿//
// ConsoleCSharp
//
// Copyright (c) 2016 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using System;

namespace ConsoleCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            int? nullableInt = 257;

            // 非null許容型の変数にそのまま代入するとコンパイルエラーが発生する
            // 'int?' を 'byte' に暗黙的に変換できません。明示的な変換が存在します。(cast が不足していないかどうかを確認してください)
            // byte byteValue = nullableInt;

            // byteは255までしか入らないため、 castするとオーバーフローして 1 になる
            byte byteValue = (byte)nullableInt;
            Console.WriteLine(byteValue);

            // Valueプロパティを使用すればコンパイルエラーが発生し、誤りに気づける
            // 型 'int' を 'byte' に暗黙的に変換できません。明示的な変換が存在します。(cast が不足していないかどうかを確認してください)
            byteValue = nullableInt.Value;

            Console.ReadLine();
        }
    }
}
